ARG CONTAINER_IMAGE=registry.fedoraproject.org/fedora
ARG CONTAINER_TAG=40
ARG CONTAINER_SHA=sha256:58d1da08b8a48a3c9c45a59c27f409af7b95bd8248452bbd857c5b4259149d1f

FROM ${CONTAINER_IMAGE}:${CONTAINER_TAG}@${CONTAINER_SHA}
    
ARG KUKSA_VER=0.4.0
ARG KUKSA_VAL_BUILD_TYPE=Release

# Install required packages
RUN dnf -y update && dnf install -y \
patch \
cmake \
g++ \
wget \
openssl-devel \
libstdc++ \
bzip2 \
git \
protobuf \
protobuf-devel \
grpc \
grpc-cpp \
grpc-devel \
boost \
boost-devel \
mosquitto \
mosquitto-devel \
net-tools \
iputils \
iproute

# Download kuksa
RUN git clone --branch ${KUKSA_VER} https://github.com/eclipse/kuksa.val.git

# Patches
COPY /files /
RUN patch -t -i /kuksa.val/kuksa-val-server/grpc.cmake.diff /kuksa.val/kuksa-val-server/grpc.cmake
RUN patch -t -i /kuksa.val/kuksa-val-server/boost.cmake.diff /kuksa.val/kuksa-val-server/boost.cmake

# Build
RUN mkdir -p /kuksa.val/kuksa-val-server/_build

WORKDIR /kuksa.val/kuksa-val-server/_build

RUN (cd ../..; git submodule init; git submodule update)

RUN cmake \
-DMOSQUITTO_INCLUDE_DIR=/usr/include \
-DBoost_INCLUDE_DIR=/usr/include \
-DCMAKE_BUILD_TYPE=Release \
.. && \
make -j 4  && \
make install && \
make clean

WORKDIR /

# Move files around
RUN mkdir -p /etc/kuksa-val-server/{tls,vss}

RUN mv /usr/local/bin/kuksa-val-server/kuksa-val-server /usr/bin/kuksa-val-server && \
mv /usr/local/bin/kuksa-val-server/*.pub /etc/kuksa-val-server/tls && \
mv /usr/local/bin/kuksa-val-server/*.pem /etc/kuksa-val-server/tls && \
mv /usr/local/bin/kuksa-val-server/*.key /etc/kuksa-val-server/tls && \
mv /usr/local/bin/kuksa-val-server/vss* /etc/kuksa-val-server/vss/

ENTRYPOINT ["/usr/bin/kuksa-val-server"]

CMD ["--insecure", "--address", "0.0.0.0",  "--vss", "/etc/kuksa-val-server/vss/vss_release_4.0.json", "--cert-path", "/etc/kuksa-val-server/tls", "--log-level", "ALL"]
